unit UGoal2DTeamAway;

// Players with this goal will be scared by some team member and scape from them.

interface

uses UGoal, UPlayer2D, UTeam;

type TGoal2DTeamAway = class(TGoal)
  private
    BullyTeam: TTeam;
  protected
    procedure ReadQuantity(v: TObject); override;
  public
    constructor create(Sender: TObject; T: TTeam);
  end;


implementation

uses Math;


constructor TGoal2dTeamAway.create(Sender: TObject; T: TTeam);
begin
  inherited create(Sender);
  BullyTeam:= T;
  DisplayName:= 'Avoid others';
  NominalQuantity:= 1; // Activate it as a mood feeling
end;

// Quantity is the product of the distances to others using my own size as unit.
// If all are at >size distance, mood will be >1, but as they come near, it drops down.
procedure TGoal2dTeamAway.ReadQuantity(v: TObject);
var
  i: integer;
  d: double;
  p, p2: TPlayer2D;
begin
  inherited;
  Quantity:= 1; // Initially you have no mood change
  p:= TPLayer2D(v);
  if (Strength=0) then exit;
  // All players on the "bully team" do repel me:
  for i:= 0 to BullyTeam.PlayerCount-1 do begin
    p2:= TPlayer2D(BullyTeam.Player[i]);
    if (p<>p2) then begin
      // Strength also control the radio: 1 means keep out of a radius 10 times your size free.
      d:= Sqrt(Sqr(p.PosX-p2.PosX)+Sqr(p.PosY-p2.PosY)) / (10*Strength*p.Size);
      // Use Min(d,1) = just avoid being too near but more distance is not beeter fomr here.
      // Quantity:= Min(d, Quantity);
      //
      // Go as far as possible from all others.
      Quantity:= Quantity * d;
    end;
  end;
end;

end.
