unit UGoalBurnOut;

interface

uses UGoal, UPlayer2D, UTeam;

type TGoalBurnOut = class(TGoal)
  private
  protected
    procedure ReadQuantity(v: TObject); override;
  public
    constructor create(Sender: TObject);
  end;


implementation

uses SysUtils, Forms, UTrack, UTrack2D, Graphics, URocket;


constructor TGoalBurnOut.create(Sender: TObject);
begin
  inherited;
  if not (Sender is TRocket) then
    raise Exception.create('BurnOut goal is only fro Rockets.');
  DisplayName:= 'Stole energy from others';
end;

// I can take energy from players if I am touching it with my fire:
procedure TGoalBurnOut.ReadQuantity(v: TObject);
var
  i: integer;
  FlameX, FlameY: double;
  OldEnergy, Sucked: double;
  p: TPlayer2D;
  r: TRocket;
begin
  inherited;
  // By default, no loose or gain:
  OldQuantity:= 10; // 10% is the scale, store 10% of energy for a gain of 1.
  Quantity:=    10;
  // Only rockets can burn other agent with it fire:
  r:= TRocket(v);
  // Dead rockets can't fire you:
  if (r.Energy = 0) or (r.dead) then exit;
  // End point of the rocket flame?
  FlameX:= round(r.PosX - cos(r.Angle) * (r.Size + r.MainPower));
  FlameY:= round(r.PosY - sin(r.Angle) * (r.Size + r.MainPower));
  // Look around for other players being touched:
  for i:= 0 to TTrack(r.Track).PlayerCount-1 do begin
    p:= TPlayer2D(TTrack(r.Track).Player[i]);
    // I can't fire my self.
    if p<>TPlayer2D(r) then begin
      // Touched if distance from flame end to the other player < its size:
      if Sqrt(Sqr(p.PosX - FlameX) + Sqr(p.PosY - FlameY)) < p.Size then begin
        // OK, the victim is at reach, take its energy!
        OldEnergy:= p.Energy;
        // Adjusted so it takes 1 second to drain 100% of the energy:
        // First, take energy from the victim:
        p.Energy:= p.Energy - 100*p.StepSeconds;
        Sucked:= OldEnergy - p.Energy;
        // Half of the taken energy disipate, the other half is for the rocket:
        OldEnergy:= r.Energy;
        r.Energy:= r.Energy + Sucked/2;
        // If you kill him, then it is great gain, so score this fure x25!
        if (p.Energy = 0) then begin
          Quantity:= 100; // Score x10!
        end else begin
          // Gain = Energy obtained (10% is a gain of 1 unit):
          Quantity:= OldQuantity + 10 * (r.Energy - OldEnergy);
        end;
        // Debuging must be made now, after this I wont recall who was the victim:
        if (not r.Imagining) and (r.GoalSet.Debug) and (TTrack(p.Track) is TTrack2D) then begin
          TTrack2D(r.Track).Img.Canvas.Pen.Color:= clRed;
          TTrack2D(r.Track).Img.Canvas.Pen.Width:= 3;
          TTrack2D(r.Track).Img.Canvas.MoveTo(round(r.PosX), round(r.PosY));
          TTrack2D(r.Track).Img.Canvas.LineTo(round(p.PosX), round(p.PosY));
          TTrack2D(r.Track).Img.Canvas.Pen.Width:= 1;
          Application.ProcessMessages;
        end;
      end
    end;
  end;
end;


end.
