unit UGoalDuplicate;

interface

uses UGoal, UPlayer, UTrack2D, UUtils;

type TGoalDuplicate = class(TGoal)
  private
  protected
  public
    constructor create(c: double); override;
    procedure CalcScore(FireAt: TGoalFire); override;
    procedure NeutralDraw; override;
  end;


implementation

uses Classes, Graphics, UTrack;

constructor TGoalDuplicate.create;
begin
  inherited;
  fDisplayName:= 'Duplicating is sexy';
  AlwaysDraw:= true;
end;

procedure TGoalDuplicate.CalcScore(FireAt: TGoalFire);
var p: TPlayer;
begin
  inherited;
  if (FireAt = gfEnd) then begin
    p:= TPlayer(Player);
    // If player has plenty of energy then it could decide to duplicate itself:
    if (p.HadDuplicated) then begin
      Score:= 1000.0;
    end;
  end;
end;

procedure TGoalDuplicate.NeutralDraw;
var
  p, p2: TPlayer;
  C: TCanvas;
  i, g: integer;
  T: TTrack2D;
  cx, cy: integer;
  w, h, m: integer;
begin
  if (not Assigned(player)) then exit;
  p:= TPlayer(player); // I still have it from last player's CalScore
  if p.Imagining then exit;
  // Get to the track so you can access the player list:
  T:= TTrack2D(p.Track);
  C:= T.Img.Canvas;
  // Rectangle where to draw players' goal strengths:
  C.Brush.Color:= clWhite;
  C.Pen.Color:= clBlack;
  w:= 120;
  h:= 80;
  m:= 5;
  C.Rectangle(10, 10, 10+2*m+w, 10+2*m+h);
  C.Pen.Color:= RGBtoColor(100,100,100);
  C.Rectangle(10+m, 10+m, 10+m+w, 10+m+h);
  // Number of players:
  C.Rectangle(10+m, 10+2, 10+m+T.PlayerCount, 10+m-2);
  C.Brush.Style:= bsClear;
  for i:= 0 to T.PlayerCount-1 do begin
    p2:= T.Player2D[i];
    // Draw vertical lines:
    if (i=0) then begin
      for g:= 0 to p2.GoalCount-1 do begin
        cx:= round(10+m+w*g/(p2.GoalCount-1));
        C.MoveTo(cx, 10+m);
        C.LineTo(cx, 10+m+h);
      end;
    end;
    // Draw goals strength:
    if not p2.Dead then begin
      for g:= 0 to p2.GoalCount-1 do begin
        cx:= round(10+m+w*g/(p2.GoalCount-1));
        cy:= round(10+m+h* (1 - p2.Goal[g].Strength/p2.Goal[g].MaxStrength));
        if (g=0) then begin
          C.Pen.Color:= p2.Color;
          C.MoveTo(cx, cy);
        end else begin
          C.LineTo(cx, cy);
        end;
        // C.Ellipse(cx-5, cy-5, cx+5, cy+5);
      end;
    end;
  end;
end;

end.
