unit UGoalEnergy;

interface

uses UGoal, UPlayer;

type TGoalEnergy = class(TGoal)
  private
  protected
    procedure ReadQuantity(v: TObject); override;
  public
    constructor create(Sender: TObject); override;
  end;


implementation

uses Math;


constructor TGoalEnergy.create(Sender: TObject);
begin
  inherited;
  DisplayName:= 'Energy';
  //Asymmetry:= 0.5;
  Strength:= 0.8;
  //Minimum:= 10;
  NominalQuantity:=    100; // Quantity is OK at 100% (Happy=1)
  ReactionMSeconds:= 10000; // Loose danger if it occurs before 7s
  Urgency:= 0.8;            // How fast this danger feeling grows
end;

procedure TGoalEnergy.ReadQuantity(v: TObject);
begin
  // Dividing by 10 just adjust scales so I can safely use goals with strength of 1
  OldQuantity:= Max(0, TPlayer(v).OldEnergy-5) / 10;
  Quantity:=    Max(0, TPlayer(v).Energy-5) / 10;
  Quantity:= Quantity * 1;
end;

end.
