unit UGoalHealth;

interface

uses UGoal, UPlayer;

type TGoalHealth = class(TGoal)
  public
    constructor create(Sender: TObject); override;
    procedure ReadQuantity(v: TObject); override;
  end;

implementation

uses Math;

constructor TGoalHealth.create(Sender: TObject);
begin
  inherited;
  DisplayName:= 'Health';
  //Asymmetry:= 1; // (Loose is x2 important that earning)
  // Happy Feeling:
  NominalQuantity:=   100; // Quantity is OK at 100%
  // Gain feeling:
  ReactionMSeconds:= 10000; // Loose danger if it occurs before 7s
  Urgency:= 2.0;            // How fast this danger feeling grows
  // Asymmetry: Strenght for Loose = 1, for Gain = 1/2:
  Strength:= 1;
  Asymmetry:= 5;
end;

procedure TGoalHealth.ReadQuantity(v: TObject);
begin
  // Dividing by 10 just adjust scales so I can safely use goals with strength of 1
  OldQuantity:= TPlayer(v).OldHealth / 10;
  Quantity:=    TPlayer(v).Health / 10;
  Quantity:= Quantity * 1;
end;

end.
