unit UUtils;

//
// UTILS NOT WORTH COPYING ALL OVER THE CODE
//

interface

uses Math, Graphics, Windows;


procedure Color2RGB(Color: TColor; var R,G,B: integer);
function  RGB2Color(R, G, B: integer): TColor;
procedure LightColor(var Color: TColor; Coef: double);
procedure DarkColor(var Color: TColor; Coef: double);


implementation



// COLOR STUFF
// ===========
procedure Color2RGB(Color: TColor; var R,G,B: integer);
begin
  Color:=ColorToRGB(Color);
	r:=GetRValue(Color);
	g:=GetGValue(Color);
	b:=GetBValue(Color);
end;

function RGB2Color(R, G, B: integer): TColor;
begin
  result:= Min(255,R) + 256 * (Min(255,G) + 256 * Min(255,B));
end;

procedure LightColor(var Color: TColor; Coef: double);
var
  R, G, B: integer;
begin
  if Coef=0 then exit;
  Color2RGB(Color, R, G, B);
  R:= Max(0, Min(255, round(R+(255-R)*Coef)));
  G:= Max(0, Min(255, round(G+(255-G)*Coef)));
  B:= Max(0, Min(255, round(B+(255-B)*Coef)));
  Color:= RGB2Color(R, G, B);
end;

procedure DarkColor(var Color: TColor; Coef: double);
var
  Lum: double;
  R, G, B: integer;
begin
  if Coef=1 then exit;
  Color2RGB(Color, R, G, B);
  Lum:= (R+G+B) / (3*255);
  Coef:= Power(Coef, ((Lum+Coef*2)/(1+Coef*2)));
  R:= Round(R*Coef);
  G:= Round(G*Coef);
  B:= Round(B*Coef);
  Color:= RGB2Color(R,G,B);
end;

end.
